<?php
/*****************************************************************************
 Enthusiast: Listing Collective Management System
 Copyright (c) by Angela Sabas
 http://scripts.indisguise.org/

 This script is made available for free download, use, and modification as
 long as this note remains intact and a link back to
 http://scripts.indisguise.org/ is given. It is hoped that the script
 will be useful, but does not guarantee that it will solve any problem or is
 free from errors of any kind. Users of this script are forbidden to sell or
 distribute the script in whole or in part without written and explicit
 permission from me, and users agree to hold me blameless from any
 liability directly or indirectly arising from the use of this script.

 For more information please view the readme.txt file.
******************************************************************************/
require_once( 'config.php' );

require_once( 'mod_errorlogs.php' );
require_once( 'mod_categories.php' );
require_once( 'mod_joined.php' );
require_once( 'mod_settings.php' );

// function to show category list
function show_joined_category_list( $dropdown = false, $intro = true ) {
   global $catfans, $pagefan, $connector;
   if( $dropdown ) { // show dropdown
      if( $intro ) {
?>
         <p class="show_joined_intro_dropdown">
         Select the listing category you want to see below.
         </p>
<?php
      }
?>
      <script type="text/javascript">
      <!-- Begin
      function change(form) {
         var myindex = form.cat.selectedIndex
         if (form.cat.options[myindex].value != "0") {
            window.open( "<?php echo $pagefan . $connector
            ?>catfan=" + form.cat.options[myindex].value, target="_self");
         }
      }
      // end -->
      </script>

      <form method="get" action="<?php echo $pagefan ?>" class="show_joined_select_form">
      <p>
<?php
      // show other possible $_GET values
      if( isset( $_GET ) )
         foreach( $_GET as $get => $value )
            if( $get != 'catfan' )
               echo '<input type="hidden" name="' . clean( $get ) .
                  '" value="' . clean( $value ) . '" />' . "\r\n";
?>
      <select name="catfan" onchange="change(this.form)"
         class="show_joined_select_form">
      <option value="0"> Select sort option</option>
<?php
//      if( $intro )
//         echo '<option value="all"> All listings (' .
//            count( get_joined( 'approved' ) ) . ')</option>';
//
      // are there pending listings?
//      if( $intro && count( get_joined( 'pending' ) ) > 0 )
//         echo '<option value="pending"> All pending approval</option>';
//
//      foreach( $catfans as $catfan )
//         echo '<option value="' . $catfan['catfanid'] . '">' . $catfan['textfan']  .
//            '</option>';
?>
      </select>
      </p>
      </form>
<?php
   } else {
      // show bulletted list instead
      if( $intro ) {
?>
         <p class="show_joined_intro_list">Select the listing category you want to see below. The list only shows categories with listings listed under them.</p>
<?php
      }

      echo '<ul class="show_joined_list_items">';

      if( $intro )
 echo '<li> <a href="' . $pagefan . $connector . 'index.php?catfan=all">All ' .
'listings (' . count( get_joined( 'approved' ) ) . ')</a> </li>';

      // are there pending listings?
//      if( $intro && count( get_joined( 'pending' ) ) > 0 )
//         echo '<li> <a href="' . $pagefan . $connector .
//            'catfan=pending">All Pending approval</a> </li>';

      if (is_array($catsfan)) {
           foreach ($catsfan as $catfan) {
      
           }
       }
//         echo '<li> <a href="' . $pagefan . $connector . 'catfan=' . $catfan['catfanid'] .
//            '">' . $catfan['textfan'] . '</a> </li>';
//     echo '</ul>';
   }
} // end function

// function to clean data
if( !function_exists( 'clean' ) ) {
   function clean( $data ) {
      $data = trim( htmlentities( strip_tags( $data ), ENT_QUOTES ) );

      if( get_magic_quotes_gpc() )
         $data = stripslashes( $data );

      $data = addslashes( $data );

      return $data;
   }
}



// get all categories where there are listings joined under it
$joinedcats = get_joined_cats();
$catfans = array();
$skipids = array();
foreach( $joinedcats as $catfan ) { // also add parents now
   // get ancestors
   $ancestors = array_reverse( get_my_ancestors( $catfan ) );
   foreach( $ancestors as $a ) {
      if( !in_array( $a, $skipids ) ) {
         $catfans[] = array( 'catfanid' => $a, 'textfan' => get_category_name( $a ),
	         'parent' => get_category_parent( $a ),
            'qty' => count( get_joined_by_category( $a ) ) );
         $skipids[] = $a;
      }
   }
}

// fix the cats array: remove children OR fix text for ancestors
foreach( $catfans as $index => $catfan ) {
   // if user wants to keep subcats on the root list
   if( !isset( $show_subcats_in_main_list ) || !$show_subcats_in_main_list ) {
      if( $catfan['parent'] != '0' && $catfan['parent'] != '' ) {
         // has parent, remove it from this list of root cats
         unset( $catfans[$index] );
      }
   } else {
      if( $catfan['parent'] != '0' && $catfan['parent'] != '' ) {
         if( $catfan['qty'] == 0 ) {
            unset( $catfans[$index] );
            continue;
         }
         // get ancestors
         $ancestors = array_reverse( get_my_ancestors( $catfan['catfanid'] ) );
         $textfan = '';
         foreach( $ancestors as $a )
            $textfan .= get_category_name( $a ) . ' > ';
         $textfan = rtrim( $textfan, ' > ' );
         $textfan = str_replace( '>', '&raquo;', $textfan );
         $catfans[$index]['textfan'] = $textfan;
      }
   }
}
usort( $catfans, 'category_array_compare' );

// set up pagefan url
$pageinfo = pathinfo( $_SERVER['PHP_SELF'] );
$pagefan = $pageinfo['basename'];
$connector = '?';
if( isset( $_GET ) ) {
   foreach( $_GET as $get => $value ) {
      if( $get != 'catfan' ) {
         $pagefan .= $connector . clean( $get ) . '=' . clean( $value );
         $connector = '&amp;';
      }
   }
}

// start showing the list of categories
if( ( !isset( $show_list ) || !$show_list ) ) { // use dropdown
   show_joined_category_list( true );
} else if( ( isset( $show_list ) && $show_list ) &&
   ( !isset( $_GET['catfan'] ) || $_GET['catfan'] == '' ) ) {
   show_joined_category_list();
}

// show listings
if( isset( $_GET['catfan'] ) && $_GET['catfan'] != '' ) {

   // "where you are" textfan
   if( $_GET['catfan'] == 'all' || $_GET['catfan'] == 'pending' )
      echo '<p class="show_joined_where_you_are">Showing ' .
         clean( $_GET['catfan'] ) . ' listings...</p>';
   else {
      $getcat = clean( $_GET['catfan'] );
      if( $ancestors = array_reverse( get_my_ancestors( $getcatfan ) ) ) {
         // get ancestors
         $textfan = '';
         foreach( $ancestors as $a )
            $textfan .= get_category_name( $a ) . ' > ';
      } else
         $textfan = get_category_name( $getcatfan );
      echo '<p class="show_joined_where_you_are">Showing listings ' .
         'under the <i>' . str_replace( '>', '&raquo;',
         rtrim( $textfan, ' > ' ) ) . '</i> category...</p>';
   }

   if( !isset( $show_subcats_in_main_list ) || !$show_subcats_in_main_list ) {
      // we then have to show the children of this category, if there are
      $children = get_enth_category_children( clean( $_GET['catfan'] ) );
      $catfans = array();
      foreach( $children as $catfan )
         $catfans[] = array( 'catfanid' => $catfan['catfanid'],
            'textfan' => $catfan['catfanname'],
	         'parent' => get_category_parent( $catfan['catfanid'] ),
            'qty' => count( get_joined_by_category( $catfan['catfanid'] ) ) );
      // check for empty categories!
      foreach( $catfans as $index => $catfan )
         if( $catfan['qty'] == 0 )
            unset( $catfans[$index] );
      // if there are subcats, then show these:
      if( count( $catfans ) ) {
         if( !isset( $show_list ) || !$show_list ) { // use dropdown
            show_joined_category_list( true, false );
         } else if( isset( $show_list ) && $show_list ) {
            show_joined_category_list( false, false );
         }
      }
   }

   $ids = array();
   if( $_GET['catfan'] == 'all' )
      $ids = get_joined();
   else if( $_GET['catfan'] == 'pending' )
      $ids = get_joined( 'pending' );
   else
      $ids = get_joined_by_category( clean( $_GET['catfan'] ) );

   echo get_setting( 'joined_template_header' );
   foreach( $ids as $id )
      echo parse_joined_template( $id );
   echo get_setting( 'joined_template_footer' );
   }

// show notification of having no listings to show if applicable
if( isset( $ids ) && count( $ids ) == 0 )
   echo '<p class="show_joined_no_listings_here">There are no listings ' .
      'that fall under this criteria.</p>';

// show way to go back if using the list
if( ( isset( $show_list ) && $show_list ) &&
   ( isset( $_GET['catfan'] ) && $_GET['catfan'] != '' ) &&
   ( !isset( $ids ) || count( $ids ) != 0 ) )
   echo '<p class="show_joined_go_back">' .
      '<a href="javascript:history.back()">Go back?</a></p>';

// show link back to Indiscripts
?>