<?php
/*****************************************************************************
 Enthusiast: Listing Collective Management System
 Copyright (c) by Angela Sabas
 http://scripts.indisguise.org/

 This script is made available for free download, use, and modification as
 long as this note remains intact and a link back to
 http://scripts.indisguise.org/ is given. It is hoped that the script
 will be useful, but does not guarantee that it will solve any problem or is
 free from errors of any kind. Users of this script are forbidden to sell or
 distribute the script in whole or in part without written and explicit
 permission from me, and users agree to hold me blameless from any
 liability directly or indirectly arising from the use of this script.

 For more information please view the readme.txt file.
******************************************************************************/
require 'config.php';

require_once( 'mod_errorlogs.php' );
require_once( 'mod_categories.php' );
require_once( 'mod_members.php' );
require_once( 'mod_owned.php' );
require_once( 'mod_settings.php' );

// function to show category list
if( !function_exists( 'show_owned_category_list' ) ) {
   function show_owned_category_list( $dropdown = false, $intro = true ) {
      global $catsfan, $pagefan, $connector;
      if( $dropdown ) { // show dropdown
         if( $intro ) {
?>
            <p class="show_owned_intro_dropdown">
            Select the listing category you want to see below. The dropdown
            only shows categories with listings listed under them.
            </p>
<?php
         }
?>
         <script type="text/javascript">
         <!-- Begin
         function change(form) {
            var myindex = form.cat.selectedIndex
            if (form.cat.options[myindex].value != "0") {
               window.open( "<?php echo $pagefan . $connector
               ?>catfan=" + form.cat.options[myindex].value, target="_self");
            }
         }
         // end -->
         </script>

         <form method="get" action="<?php echo $pagefan ?>" class="show_owned_select_form">
         <p>
<?php
         // show other possible $_GET values
         if( isset( $_GET ) )
            foreach( $_GET as $get => $value )
               if( $get != 'catfan' )
                  echo '<input type="hidden" name="' . clean( $get ) .
                     '" value="' . clean( $value ) . '" />' . "\r\n";
?>
         <select name="catfan" onchange="change(this.form)"
            class="show_owned_select_form">
         <option value="0"> Select sort option</option>
<?php
         if( $intro )
            echo '
<option value="all"> All listings</option>';
         foreach( $catsfan as $catfan )
            echo '
	<li><a href="' . $pagefan . $connector . 'catfan=' . $catfan['catfanid'] .
               '"><option value="' . $catfan['catfanid'] . '">' . $catfan['textfan']  .
               '</option></a></li>
';
?>
         </select>
         </p>
         </form>
<?php
      } else {
         // show bulletted list instead
         if( $intro ) {
?>
            <p class="show_owned_intro_list">Select the listing category you want to see below. The list only shows categories with listings listed under them.</p>
<?php
         }

         echo '<ul class="show_owned_list_items">';

         if( $intro )
            echo '<li> <a href="' . $pagefan . $connector . 'index.php?catfan=all">All ' .
               'categories</a> </li>';
                
         if (is_array($catsfan)) {
             foreach ($catsfan as $catfan) {
        
             }
         }
// 
//              echo '<li> <a href="' . $pagefan . $connector . 'catfan=' . $catfan['catfanid'] .
//               '">' . $catfan['textfan'] . '</a> </li>';
//         echo '</ul>';
         
      }
   } // end function
}

// function to clean data
if( !function_exists( 'clean' ) ) {
   function clean( $data ) {
      $data = trim( htmlentities( strip_tags( $data ), ENT_QUOTES ) );

      if( get_magic_quotes_gpc() )
         $data = stripslashes( $data );

      $data = addslashes( $data );

      return $data;
   }
}


// get all categories where there are fanlistings owned under it
$ownedcats = get_owned_cats( $status );
$catsfan = array();
$skipids = array();
foreach( $ownedcats as $catfan ) { // also add parents now
   // get ancestors
   $ancestors = array_reverse( get_my_ancestors( $catfan ) );
   foreach( $ancestors as $a ) {
      if( !in_array( $a, $skipids ) ) {
         $catsfan[] = array( 'catfanid' => $a, 'textfan' => get_category_name( $a ),
	         'parent' => get_category_parent( $a ),
            'qty' => count( get_owned_by_category( $a ) ) );
         $skipids[] = $a;
      }
   }
}

// fix the cats array: remove children OR fix textfan for ancestors
foreach( $catsfan as $index => $catfan ) {
   if( !isset( $show_subcats_in_main_list ) || !$show_subcats_in_main_list ) { 
      if( $catfan['parent'] != '0' && $catfan['parent'] != '' ) {
         unset( $catsfan[$index] );
      }
   } else { 
      if( $catfan['parent'] != '0' && $catfan['parent'] != '' ) {
         if( $catfan['qty'] == 0 ) {
            unset( $catsfan[$index] );
            continue;
         }
         // get ancestors
         $ancestors = array_reverse( get_my_ancestors( $catfan['catfanid'] ) );
         $textfan = '';
         foreach( $ancestors as $a )
            $textfan .= get_category_name( $a ) . ' > ';
         $textfan = rtrim( $textfan, ' > ' );
         $textfan = str_replace( '>', '&raquo;', $textfan );
         $catsfan[$index]['textfan'] = $textfan;
      }
   }
}
usort( $catsfan, 'category_array_compare' );

// set up page url
$pageinfo = pathinfo( $_SERVER['PHP_SELF'] );
$pagefan = $pageinfo['basename'];
$connector = '?';
if( isset( $_GET ) ) {
   foreach( $_GET as $get => $value ) {
      if( $get != 'catfan' ) {
         $pagefan .= $connector . clean( $get ) . '=' . clean( $value );
         $connector = '&amp;';
      }
   }
}

if( ( !isset( $hide_dropdown ) || $hide_dropdown == false ) &&
   ( !isset( $show_list ) || $show_list == false ) ) {
   show_owned_category_list( true );
} else if( ( !isset( $hide_dropdown ) || $hide_dropdown == false ) &&
   ( isset( $show_list ) && $show_list ) &&
   ( !isset( $_GET['catfan'] ) || $_GET['catfan'] == '' ) &&
   ( !isset( $show ) || $show == '' ) ) {
   show_owned_category_list();
}

if( !isset( $status ) ) {
	echo '<p style="color: red;">ERROR: <code>$status</code> is not set.</p>';
   return;
}

if( ( isset( $_GET['catfan'] ) && $_GET['catfan'] != '' ) ||
   ( isset( $show ) && $show != '' ) ) {

   // get fanlistings under that category, and depending on $status
   $ids = array();
   if( ( isset( $_GET['catfan'] ) && $_GET['catfan'] == 'all' ) ||
      ( isset( $show ) && $show == 'all' ) ) {
      echo '<p class="show_owned_where_you_are">Showing all ' . $status .
         ' fanlistings...</p>';
      $ids = get_owned( $status );

   } else if( ( isset( $_GET['catfan'] ) && $_GET['catfan'] != 'all' ) ||
      ( isset( $show ) && $show != 'all' ) ) {
      $catfanid = 0;
      if( isset( $_GET['catfan'] ) && ctype_digit( $_GET['catfan'] ) )
         $catfanid = clean( $_GET['catfan'] );
      else if( isset( $show ) )
         $catfanid = $show;

      if( $ancestors = array_reverse( get_my_ancestors( $catfanid ) ) ) {
         // get ancestors
         $textfan = '';
         foreach( $ancestors as $a )
            $textfan .= get_category_name( $a ) . ' > ';
      } else $textfan = get_category_name( $catfanid );
      echo '<p class="show_owned_where_you_are">Showing fanlistings ' .
         'under the <i>' . str_replace( '>', '&raquo;', rtrim( $textfan, ' > ' ) ) .
         '</i> category...</p>';

      if( $status == 'pending' )
         $ids = get_owned_by_category( $catfanid, '0' );
      else if( $status == 'upcoming' )
         $ids = get_owned_by_category( $catfanid, 1 );
      else
         $ids = get_owned_by_category( $catfanid, 2 );
   }

   if( ( !isset( $show_subcats_in_main_list ) || !$show_subcats_in_main_list )
      && isset( $_GET['catfan'] ) ) {
      // we then have to show the children of this category, if there are
      $children = get_enth_category_children( clean( $_GET['catfan'] ) );
      $catsfan = array();
      $status_number = ( $status == 'pending' ) ? '0' : ( ( $status == 'upcoming' ) ? 1 : 2 );
      foreach( $children as $catfan )
         $catsfan[] = array( 'catfanid' => $catfan['catfanid'],
            'textfan' => $catfan['catfanname'],
	         'parent' => get_category_parent( $catfan['catfanid'] ),
            'qty' => count( get_owned_by_category( $catfan['catfanid'], $status_number ) ) );
      // check for empty categories!
      foreach( $catsfan as $index => $catfan ) {
         $children = get_enth_category_children( $catfan['catfanid'] );
         $childqty = 0;
         foreach( $children as $c )
            $childqty += count( get_owned_by_category( $c['catfanid'], $status_number ) );
         if( $catfan['qty'] == 0 && $childqty == 0 )
            unset( $catsfan[$index] );
      }
      if( count( $catsfan ) && ( !isset( $show_list ) || !$show_list ) ) { // use dropdown
         show_owned_category_list( true, false );
      } else if( count( $catsfan ) && isset( $show_list ) && $show_list ) {
         show_owned_category_list( false, false );
      }
   }

   echo get_setting( 'owned_template_header' );
   foreach( $ids as $id )
      echo parse_owned_template( $id );
   echo get_setting( 'owned_template_footer' );
}

// show notification of having no listings to show if applicable
if( isset( $ids ) && count( $ids ) == 0 )
   echo '<p class="show_owned_no_listings_here">There are no listings ' .
      'that fall under this criteria.</p>';

// show way to go back if using the list
if( ( !isset( $hide_dropdown ) || $hide_dropdown == false ) &&
   ( isset( $show_list ) && $show_list ) &&
   ( isset( $_GET['catfan'] ) && $_GET['catfan'] != '' ) ||
   ( isset( $show ) && $show != '' ) &&
   ( !isset( $ids ) || count( $ids ) != 0 ) &&
   $show != 'all' )
   echo '<p class="show_owned_go_back"><a href="javascript:history.back()">Go ' .
      'back?</a></p>';

// show link back to Indiscripts
?>